Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/LazyAssetManager.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/LazyAssetManager.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/LazyAssetManager.php	(revision 7265)
@@ -0,0 +1,204 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory;
+
+use Assetic\AssetManager;
+use Assetic\Factory\Loader\FormulaLoaderInterface;
+use Assetic\Factory\Resource\ResourceInterface;
+
+/**
+ * A lazy asset manager is a composition of a factory and many formula loaders.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class LazyAssetManager extends AssetManager
+{
+    private $factory;
+    private $loaders;
+    private $resources;
+    private $formulae;
+    private $loaded;
+    private $loading;
+
+    /**
+     * Constructor.
+     *
+     * @param AssetFactory $factory The asset factory
+     * @param array        $loaders An array of loaders indexed by alias
+     */
+    public function __construct(AssetFactory $factory, $loaders = array())
+    {
+        $this->factory = $factory;
+        $this->loaders = array();
+        $this->resources = array();
+        $this->formulae = array();
+        $this->loaded = false;
+        $this->loading = false;
+
+        foreach ($loaders as $alias => $loader) {
+            $this->setLoader($alias, $loader);
+        }
+    }
+
+    /**
+     * Adds a loader to the asset manager.
+     *
+     * @param string                 $alias  An alias for the loader
+     * @param FormulaLoaderInterface $loader A loader
+     */
+    public function setLoader($alias, FormulaLoaderInterface $loader)
+    {
+        $this->loaders[$alias] = $loader;
+        $this->loaded = false;
+    }
+
+    /**
+     * Adds a resource to the asset manager.
+     *
+     * @param ResourceInterface $resource A resource
+     * @param string            $loader   The loader alias for this resource
+     */
+    public function addResource(ResourceInterface $resource, $loader)
+    {
+        $this->resources[$loader][] = $resource;
+        $this->loaded = false;
+    }
+
+    /**
+     * Returns an array of resources.
+     *
+     * @return array An array of resources
+     */
+    public function getResources()
+    {
+        $resources = array();
+        foreach ($this->resources as $r) {
+            $resources = array_merge($resources, $r);
+        }
+
+        return $resources;
+    }
+
+    /**
+     * Checks for an asset formula.
+     *
+     * @param string $name An asset name
+     *
+     * @return Boolean If there is a formula
+     */
+    public function hasFormula($name)
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        return isset($this->formulae[$name]);
+    }
+
+    /**
+     * Returns an asset's formula.
+     *
+     * @param string $name An asset name
+     *
+     * @return array The formula
+     *
+     * @throws \InvalidArgumentException If there is no formula by that name
+     */
+    public function getFormula($name)
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        if (!isset($this->formulae[$name])) {
+            throw new \InvalidArgumentException(sprintf('There is no "%s" formula.', $name));
+        }
+
+        return $this->formulae[$name];
+    }
+
+    /**
+     * Sets a formula on the asset manager.
+     *
+     * @param string $name    An asset name
+     * @param array  $formula A formula
+     */
+    public function setFormula($name, array $formula)
+    {
+        $this->formulae[$name] = $formula;
+    }
+
+    /**
+     * Loads formulae from resources.
+     *
+     * @throws \LogicException If a resource has been added to an invalid loader
+     */
+    public function load()
+    {
+        if ($this->loading) {
+            return;
+        }
+
+        if ($diff = array_diff(array_keys($this->resources), array_keys($this->loaders))) {
+            throw new \LogicException('The following loader(s) are not registered: '.implode(', ', $diff));
+        }
+
+        $this->loading = true;
+
+        foreach ($this->resources as $loader => $resources) {
+            foreach ($resources as $resource) {
+                $this->formulae = array_replace($this->formulae, $this->loaders[$loader]->load($resource));
+            }
+        }
+
+        $this->loaded = true;
+        $this->loading = false;
+    }
+
+    public function get($name)
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        if (!parent::has($name) && isset($this->formulae[$name])) {
+            list($inputs, $filters, $options) = $this->formulae[$name];
+            $options['name'] = $name;
+            parent::set($name, $this->factory->createAsset($inputs, $filters, $options));
+        }
+
+        return parent::get($name);
+    }
+
+    public function has($name)
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        return isset($this->formulae[$name]) || parent::has($name);
+    }
+
+    public function getNames()
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        return array_unique(array_merge(parent::getNames(), array_keys($this->formulae)));
+    }
+
+    public function isDebug()
+    {
+        return $this->factory->isDebug();
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FormulaLoaderInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FormulaLoaderInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FormulaLoaderInterface.php	(revision 7265)
@@ -0,0 +1,34 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Loader;
+
+use Assetic\Factory\Resource\ResourceInterface;
+
+/**
+ * Loads formulae.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface FormulaLoaderInterface
+{
+    /**
+     * Loads formulae from a resource.
+     *
+     * Formulae should be loaded the same regardless of the current debug
+     * mode. Debug considerations should happen downstream.
+     *
+     * @param ResourceInterface $resource A resource
+     *
+     * @return array An array of formulae
+     */
+    public function load(ResourceInterface $resource);
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/BasePhpFormulaLoader.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/BasePhpFormulaLoader.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/BasePhpFormulaLoader.php	(revision 7265)
@@ -0,0 +1,159 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Loader;
+
+use Assetic\Factory\AssetFactory;
+use Assetic\Factory\Resource\ResourceInterface;
+
+/**
+ * Loads asset formulae from PHP files.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+abstract class BasePhpFormulaLoader implements FormulaLoaderInterface
+{
+    protected $factory;
+    protected $prototypes;
+
+    public function __construct(AssetFactory $factory)
+    {
+        $this->factory = $factory;
+        $this->prototypes = array();
+
+        foreach ($this->registerPrototypes() as $prototype => $options) {
+            $this->addPrototype($prototype, $options);
+        }
+    }
+
+    public function addPrototype($prototype, array $options = array())
+    {
+        $tokens = token_get_all('<?php '.$prototype);
+        array_shift($tokens);
+
+        $this->prototypes[$prototype] = array($tokens, $options);
+    }
+
+    public function load(ResourceInterface $resource)
+    {
+        if (!$nbProtos = count($this->prototypes)) {
+            throw new \LogicException('There are no prototypes registered.');
+        }
+
+        $buffers = array_fill(0, $nbProtos, '');
+        $bufferLevels = array_fill(0, $nbProtos, 0);
+        $buffersInWildcard = array();
+
+        $tokens = token_get_all($resource->getContent());
+        $calls = array();
+
+        while ($token = array_shift($tokens)) {
+            $current = self::tokenToString($token);
+            // loop through each prototype (by reference)
+            foreach (array_keys($this->prototypes) as $i) {
+                $prototype =& $this->prototypes[$i][0];
+                $options = $this->prototypes[$i][1];
+                $buffer =& $buffers[$i];
+                $level =& $bufferLevels[$i];
+
+                if (isset($buffersInWildcard[$i])) {
+                    switch ($current) {
+                        case '(': ++$level; break;
+                        case ')': --$level; break;
+                    }
+
+                    $buffer .= $current;
+
+                    if (!$level) {
+                        $calls[] = array($buffer.';', $options);
+                        $buffer = '';
+                        unset($buffersInWildcard[$i]);
+                    }
+                } elseif ($current == self::tokenToString(current($prototype))) {
+                    $buffer .= $current;
+                    if ('*' == self::tokenToString(next($prototype))) {
+                        $buffersInWildcard[$i] = true;
+                        ++$level;
+                    }
+                } else {
+                    reset($prototype);
+                    unset($buffersInWildcard[$i]);
+                    $buffer = '';
+                }
+            }
+        }
+
+        $formulae = array();
+        foreach ($calls as $call) {
+            $formulae += call_user_func_array(array($this, 'processCall'), $call);
+        }
+
+        return $formulae;
+    }
+
+    private function processCall($call, array $protoOptions = array())
+    {
+        $tmp = tempnam(sys_get_temp_dir(), 'assetic');
+        file_put_contents($tmp, implode("\n", array(
+            '<?php',
+            $this->registerSetupCode(),
+            $call,
+            'echo serialize($_call);',
+        )));
+        $args = unserialize(shell_exec('php '.escapeshellarg($tmp)));
+        unlink($tmp);
+
+        $inputs  = isset($args[0]) ? self::argumentToArray($args[0]) : array();
+        $filters = isset($args[1]) ? self::argumentToArray($args[1]) : array();
+        $options = isset($args[2]) ? $args[2] : array();
+
+        if (!isset($options['debug'])) {
+            $options['debug'] = $this->factory->isDebug();
+        }
+
+        if (!is_array($options)) {
+            throw new \RuntimeException('The third argument must be omitted, null or an array.');
+        }
+
+        // apply the prototype options
+        $options += $protoOptions;
+
+        if (!isset($options['name'])) {
+            $options['name'] = $this->factory->generateAssetName($inputs, $filters, $options);
+        }
+
+        return array($options['name'] => array($inputs, $filters, $options));
+    }
+
+    /**
+     * Returns an array of prototypical calls and options.
+     *
+     * @return array Prototypes and options
+     */
+    abstract protected function registerPrototypes();
+
+    /**
+     * Returns setup code for the reflection scriptlet.
+     *
+     * @return string Some PHP setup code
+     */
+    abstract protected function registerSetupCode();
+
+    protected static function tokenToString($token)
+    {
+        return is_array($token) ? $token[1] : $token;
+    }
+
+    protected static function argumentToArray($argument)
+    {
+        return is_array($argument) ? $argument : array_filter(array_map('trim', explode(',', $argument)));
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/FunctionCallsFormulaLoader.php	(revision 7265)
@@ -0,0 +1,53 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Loader;
+
+/**
+ * Loads asset formulae from PHP files.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class FunctionCallsFormulaLoader extends BasePhpFormulaLoader
+{
+    protected function registerPrototypes()
+    {
+        return array(
+            'assetic_javascripts(*)' => array('output' => 'js/*.js'),
+            'assetic_stylesheets(*)' => array('output' => 'css/*.css'),
+            'assetic_image(*)'       => array('output' => 'images/*'),
+        );
+    }
+
+    protected function registerSetupCode()
+    {
+        return <<<'EOF'
+function assetic_javascripts()
+{
+    global $_call;
+    $_call = func_get_args();
+}
+
+function assetic_stylesheets()
+{
+    global $_call;
+    $_call = func_get_args();
+}
+
+function assetic_image()
+{
+    global $_call;
+    $_call = func_get_args();
+}
+
+EOF;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/CachedFormulaLoader.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/CachedFormulaLoader.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Loader/CachedFormulaLoader.php	(revision 7265)
@@ -0,0 +1,68 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Loader;
+
+use Assetic\Cache\ConfigCache;
+use Assetic\Factory\Resource\IteratorResourceInterface;
+use Assetic\Factory\Resource\ResourceInterface;
+
+/**
+ * Adds a caching layer to a loader.
+ *
+ * A cached formula loader is a composition of a formula loader and a cache.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CachedFormulaLoader implements FormulaLoaderInterface
+{
+    private $loader;
+    private $configCache;
+    private $debug;
+
+    /**
+     * Constructor.
+     *
+     * When the loader is in debug mode it will ensure the cached formulae
+     * are fresh before returning them.
+     *
+     * @param FormulaLoaderInterface $loader      A formula loader
+     * @param ConfigCache            $configCache A config cache
+     * @param Boolean                $debug       The debug mode
+     */
+    public function __construct(FormulaLoaderInterface $loader, ConfigCache $configCache, $debug = false)
+    {
+        $this->loader = $loader;
+        $this->configCache = $configCache;
+        $this->debug = $debug;
+    }
+
+    public function load(ResourceInterface $resources)
+    {
+        if (!$resources instanceof IteratorResourceInterface) {
+            $resources = array($resources);
+        }
+
+        $formulae = array();
+
+        foreach ($resources as $resource) {
+            $id = (string) $resource;
+            if (!$this->configCache->has($id) || ($this->debug && !$resource->isFresh($this->configCache->getTimestamp($id)))) {
+                $formulae += $this->loader->load($resource);
+                $this->configCache->set($id, $formulae);
+            } else {
+                $formulae += $this->configCache->get($id);
+            }
+        }
+
+        return $formulae;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/DirectoryResource.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/DirectoryResource.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/DirectoryResource.php	(revision 7265)
@@ -0,0 +1,133 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Resource;
+
+/**
+ * A resource is something formulae can be loaded from.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class DirectoryResource implements IteratorResourceInterface
+{
+    private $path;
+    private $pattern;
+
+    /**
+     * Constructor.
+     *
+     * @param string $path    A directory path
+     * @param string $pattern A filename pattern
+     */
+    public function __construct($path, $pattern = null)
+    {
+        if (DIRECTORY_SEPARATOR != substr($path, -1)) {
+            $path .= DIRECTORY_SEPARATOR;
+        }
+
+        $this->path = $path;
+        $this->pattern = $pattern;
+    }
+
+    public function isFresh($timestamp)
+    {
+        if (!is_dir($this->path) || filemtime($this->path) > $timestamp) {
+            return false;
+        }
+
+        foreach ($this as $resource) {
+            if (!$resource->isFresh($timestamp)) {
+                return false;
+            }
+        }
+
+        return true;
+    }
+
+    /**
+     * Returns the combined content of all inner resources.
+     */
+    public function getContent()
+    {
+        $content = array();
+        foreach ($this as $resource) {
+            $content[] = $resource->getContent();
+        }
+
+        return implode("\n", $content);
+    }
+
+    public function __toString()
+    {
+        return $this->path;
+    }
+
+    public function getIterator()
+    {
+        return is_dir($this->path)
+            ? new DirectoryResourceIterator($this->getInnerIterator())
+            : new \EmptyIterator();
+    }
+
+    protected function getInnerIterator()
+    {
+        return new DirectoryResourceFilterIterator(new \RecursiveDirectoryIterator($this->path, \RecursiveDirectoryIterator::FOLLOW_SYMLINKS), $this->pattern);
+    }
+}
+
+/**
+ * An iterator that converts file objects into file resources.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ * @access private
+ */
+class DirectoryResourceIterator extends \RecursiveIteratorIterator
+{
+    public function current()
+    {
+        return new FileResource(parent::current()->getPathname());
+    }
+}
+
+/**
+ * Filters files by a basename pattern.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ * @access private
+ */
+class DirectoryResourceFilterIterator extends \RecursiveFilterIterator
+{
+    protected $pattern;
+
+    public function __construct(\RecursiveDirectoryIterator $iterator, $pattern = null)
+    {
+        parent::__construct($iterator);
+
+        $this->pattern = $pattern;
+    }
+
+    public function accept()
+    {
+        $file = $this->current();
+        $name = $file->getBasename();
+
+        if ($file->isDir()) {
+            return '.' != $name[0];
+        }
+
+        return null === $this->pattern || 0 < preg_match($this->pattern, $name);
+    }
+
+    public function getChildren()
+    {
+        return new self(new \RecursiveDirectoryIterator($this->current()->getPathname(), \RecursiveDirectoryIterator::FOLLOW_SYMLINKS), $this->pattern);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/IteratorResourceInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/IteratorResourceInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/IteratorResourceInterface.php	(revision 7265)
@@ -0,0 +1,21 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Resource;
+
+/**
+ * A resource is something formulae can be loaded from.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface IteratorResourceInterface extends ResourceInterface, \IteratorAggregate
+{
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/CoalescingDirectoryResource.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/CoalescingDirectoryResource.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/CoalescingDirectoryResource.php	(revision 7265)
@@ -0,0 +1,112 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Resource;
+
+/**
+ * Coalesces multiple directories together into one merged resource.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CoalescingDirectoryResource implements IteratorResourceInterface
+{
+    private $directories;
+
+    public function __construct($directories)
+    {
+        $this->directories = array();
+
+        foreach ($directories as $directory) {
+            $this->addDirectory($directory);
+        }
+    }
+
+    public function addDirectory(IteratorResourceInterface $directory)
+    {
+        $this->directories[] = $directory;
+    }
+
+    public function isFresh($timestamp)
+    {
+        foreach ($this->getFileResources() as $file) {
+            if (!$file->isFresh($timestamp)) {
+                return false;
+            }
+        }
+
+        return true;
+    }
+
+    public function getContent()
+    {
+        $parts = array();
+        foreach ($this->getFileResources() as $file) {
+            $parts[] = $file->getContent();
+        }
+
+        return implode("\n", $parts);
+    }
+
+    /**
+     * Returns a string to uniquely identify the current resource.
+     *
+     * @return string An identifying string
+     */
+    public function __toString()
+    {
+        $parts = array();
+        foreach ($this->directories as $directory) {
+            $parts[] = (string) $directory;
+        }
+
+        return implode(',', $parts);
+    }
+
+    public function getIterator()
+    {
+        return new \ArrayIterator($this->getFileResources());
+    }
+
+    /**
+     * Returns the relative version of a filename.
+     *
+     * @param ResourceInterface $file      The file
+     * @param ResourceInterface $directory The directory
+     *
+     * @return string The name to compare with files from other directories
+     */
+    protected function getRelativeName(ResourceInterface $file, ResourceInterface $directory)
+    {
+        return substr((string) $file, strlen((string) $directory));
+    }
+
+    /**
+     * Performs the coalesce.
+     *
+     * @return array An array of file resources
+     */
+    private function getFileResources()
+    {
+        $paths = array();
+
+        foreach ($this->directories as $directory) {
+            foreach ($directory as $file) {
+                $relative = $this->getRelativeName($file, $directory);
+
+                if (!isset($paths[$relative])) {
+                    $paths[$relative] = $file;
+                }
+            }
+        }
+
+        return array_values($paths);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/FileResource.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/FileResource.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/FileResource.php	(revision 7265)
@@ -0,0 +1,47 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Resource;
+
+/**
+ * A resource is something formulae can be loaded from.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class FileResource implements ResourceInterface
+{
+    private $path;
+
+    /**
+     * Constructor.
+     *
+     * @param string $path The path to a file
+     */
+    public function __construct($path)
+    {
+        $this->path = $path;
+    }
+
+    public function isFresh($timestamp)
+    {
+        return file_exists($this->path) && filemtime($this->path) <= $timestamp;
+    }
+
+    public function getContent()
+    {
+        return file_exists($this->path) ? file_get_contents($this->path) : '';
+    }
+
+    public function __toString()
+    {
+        return $this->path;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/ResourceInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/ResourceInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Resource/ResourceInterface.php	(revision 7265)
@@ -0,0 +1,43 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Resource;
+
+/**
+ * A resource is something formulae can be loaded from.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface ResourceInterface
+{
+    /**
+     * Checks if a timestamp represents the latest resource.
+     *
+     * @param integer $timestamp A UNIX timestamp
+     *
+     * @return Boolean True if the timestamp is up to date
+     */
+    public function isFresh($timestamp);
+
+    /**
+     * Returns the content of the resource.
+     *
+     * @return string The content
+     */
+    public function getContent();
+
+    /**
+     * Returns a unique string for the current resource.
+     *
+     * @return string A unique string to identity the current resource
+     */
+    public function __toString();
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/CacheBustingWorker.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/CacheBustingWorker.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/CacheBustingWorker.php	(revision 7265)
@@ -0,0 +1,78 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Worker;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Adds cache busting code
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class CacheBustingWorker implements WorkerInterface
+{
+    const STRATEGY_CONTENT = 1;
+    const STRATEGY_MODIFICATION = 2;
+
+    private $strategy;
+
+    public function __construct($strategy = self::STRATEGY_CONTENT)
+    {
+        $this->strategy = $strategy;
+    }
+
+    public function process(AssetInterface $asset)
+    {
+        $hash = hash_init('sha1');
+
+        switch($this->strategy) {
+            case self::STRATEGY_MODIFICATION:
+                hash_update($hash, $asset->getLastModified());
+                break;
+            case self::STRATEGY_CONTENT:
+                hash_update($hash, $asset->dump());
+                break;
+        }
+
+        foreach ($asset as $i => $leaf) {
+            if ($sourcePath = $leaf->getSourcePath()) {
+                hash_update($hash, $sourcePath);
+            } else {
+                hash_update($hash, $i);
+            }
+        }
+
+        $hash = substr(hash_final($hash), 0, 7);
+        $url = $asset->getTargetPath();
+
+        $oldExt = pathinfo($url, PATHINFO_EXTENSION);
+        $newExt = '-'.$hash.'.'.$oldExt;
+
+        if (!$oldExt || 0 < preg_match('/'.preg_quote($newExt, '/').'$/', $url)) {
+            return;
+        }
+
+        $asset->setTargetPath(substr($url, 0, (strlen($oldExt) + 1) * -1).$newExt);
+    }
+
+    public function getStrategy()
+    {
+        return $this->strategy;
+    }
+
+    public function setStrategy($strategy)
+    {
+        $this->strategy = $strategy;
+
+        return $this;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/WorkerInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/WorkerInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Factory/Worker/WorkerInterface.php	(revision 7265)
@@ -0,0 +1,31 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Factory\Worker;
+
+use Assetic\Asset\AssetInterface;
+
+/**
+ * Assets are passed through factory workers before leaving the factory.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface WorkerInterface
+{
+    /**
+     * Processes an asset.
+     *
+     * @param AssetInterface $asset An asset
+     *
+     * @return AssetInterface|null May optionally return a replacement asset
+     */
+    public function process(AssetInterface $asset);
+}
